## STARTING

getwd() # you must run this command to check your working direcotry
## setwd() # use this command to change wotking directory

## R SCRIPTING (AND ALSO PROJECTION METHODS OF DIMENSION REDUCTION: PCA)

print("Hello, world!") # this we used to make script "hello.r"
## dir() # use this comamnd to check if your script is in the working directory
## source("hello.r", echo=TRUE) # you have to have "hello.r" script in working directory, otherwise this command will not work

## prcomp(iris, scale=TRUE) # error (!) because prcomp wants numerical data only
str(iris) # whole iris data
str(iris[, -5]) # iris data without 5th column (contains species names) -- we need this for PCA

iris.p <- prcomp(iris[, -5], scale=TRUE)
iris.p # will show variable loadings
summary(iris.p) # will show proportions of variance

plot(iris.p$x, col=iris$Species) # nice plot but which species is whicl color?

table(iris$Species) # these are species, R oser alphabetical order to convert names (factor levels) to numbers
palette() # these are available colors so "setosa" = 1 = "black", "versicolor" = 2 = "red", and so on.

pdf("iris_pca.pdf") # this is how to make PDF with command (there are other ways too) -- first step
plot(iris.p$x, col=iris$Species) # second step
dev.off() # third step

## dir() # use this comamnd to check if your script is in the working directory
## source("iris.r", echo=TRUE) # you must have "iris.r" script in your working directory

## HOMEWORK: please download "scriptb.r" and find why it does not work (there are > 1 mistake)

## PACKAGE INSTALLATION

## install.packages("plot3D") # this command required only once
library(plot3D) # after installation, you should load the package
scatter3D(iris.p$x[, 1], iris.p$x[, 2], iris.p$x[, 3], colkey=FALSE, phi=10, col=as.numeric(iris$Species), xlab="PC1", ylab="PC2", zlab="PC3")

## DECONVOLUTION METHODS OF DIMENSION REDUCTION

## install.packages("Rdimtools") # this command required only once
library(Rdimtools)

## iris.iso <- do.isomap(iris[, -5]) # wrong command (!) because do.isomap() needs more parameters
iris.iso <- do.isomap(iris[, -5], type=c("enn", 6)) # correct: "enn" is "extended nearest neighbor" method, 6 is a radius for neighbors
plot(iris.iso$Y, col=iris$Species) # quite similar to PCA

## INTERMEDIATE METHODS OF DIMENSION REDUCTION

## install.packages("uwot") # you need this command only once
library(uwot)
iris.umap <- umap(iris[, -5])
plot(iris.umap, col=iris$Species) # not similar to PCA, groups are condensed
